<?php

namespace Drupal\lametric\Form;

use Drupal\Core\Config\Config;
use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Security\TrustedCallbackInterface;

/**
 * Class LaMetricSettingsForm.
 */
class LaMetricSettingsForm extends ConfigFormBase implements TrustedCallbackInterface {

  use LaMetricFormTrait;

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'lametric_settings_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    return parent::buildForm(
      $this->buildConnectionForm($form, $form_state),
      $form_state
    );
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $config = $this->config($this->getEditableConfigNames()[0])
      ->set('local', $form_state->getValue('type') === 'local');

    $this->action(
      $form,
      $config,
      function (
        array &$form,
        Config $config,
        $type,
        $field,
        FormStateInterface $form_state
      ) {
        $config->set(
          "types.$type.$field",
          $form_state->getValue([$type, $field])
        );
      },
      $form_state
    );

    $config->save();

    parent::submitForm($form, $form_state);
  }

}
